using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Collections;
using System.Windows.Forms;

namespace URITracker
{
    public partial class SettingsForm : Form
    {
        public int SelectedIndex = -1;
        private System.ComponentModel.Container components = null;

        public SettingsForm()
        {
            InitializeComponent();
        }

        private void buttonSettingsOK_Click(object sender, EventArgs e)
        {
            Settings.SetValue(this);
        }

        private void buttonSettingsCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            FileTypeForm form = new FileTypeForm();
            if (form.ShowDialog() == DialogResult.OK)
            {
                ListViewItem item = this.listViewFileMatches.Items.Add(form.textBoxTypeDescription.Text);
                item.SubItems.Add(form.numericUpDownMinSize.Value.ToString());
                item.SubItems.Add(form.numericUpDownMaxSize.Value.ToString());
            }
        }

        private void SettingsForm_Load(object sender, EventArgs e)
        {
            Settings.GetValue(this);
            this.comboBoxSettingsCodePage.Enabled = this.checkBoxSettingsUseWindowsDefaultCodePage.Checked == false;

            if (this.textBoxDownloadFolder.Text == "")
                this.textBoxDownloadFolder.Text = System.Environment.CurrentDirectory;

            if (SelectedIndex != -1)
                this.tabControlSettings.SelectedIndex = SelectedIndex;
        }         

        private void button8_Click(object sender, EventArgs e)
        {
            if (this.listViewFileMatches.SelectedItems.Count == 0)
                return;
            ListViewItem item = this.listViewFileMatches.SelectedItems[0];
            FileTypeForm form = new FileTypeForm();
            form.textBoxTypeDescription.Text = item.Text;
            if (item.SubItems.Count <= 1)
                item.SubItems.Add("0");
            form.numericUpDownMinSize.Value = int.Parse(item.SubItems[1].Text);
            if (item.SubItems.Count <= 2)
                item.SubItems.Add("0");
            form.numericUpDownMaxSize.Value = int.Parse(item.SubItems[2].Text);

            if (form.ShowDialog() == DialogResult.OK)
            {
                item.Text = form.textBoxTypeDescription.Text;
                item.SubItems[1].Text = form.numericUpDownMinSize.Value.ToString();
                item.SubItems[2].Text = form.numericUpDownMaxSize.Value.ToString();
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            if (this.listViewFileMatches.SelectedItems.Count == 0)
                return;
            ListViewItem item = this.listViewFileMatches.SelectedItems[0];
            item.Remove();
        }        

        private void checkBoxSettingsUseWindowsDefaultCodePage_CheckedChanged(object sender, EventArgs e)
        {
            this.comboBoxSettingsCodePage.Enabled = this.checkBoxSettingsUseWindowsDefaultCodePage.Checked == false;
        }        

        private void buttonDownloadFolderBrowse_Click(object sender, EventArgs e)
        {
            BrowseForFolderClass form = new BrowseForFolderClass();
            form.Title = "Select folder to save crawled files";
            if (form.ShowDialog() == DialogResult.OK)
                textBoxDownloadFolder.Text = form.DirectoryPath;
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        

    }
}