using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using Microsoft.Win32;
using System.Text.RegularExpressions;
using System.Resources;
using System.Threading;
using System.Runtime.InteropServices;
using System.Windows;
using URITracker;
using System.Xml;
using System.IO;
using System.Collections;


namespace URITracker
{


    public partial class MainForm : Form
    {


        #region private&Properties

        int nFirstTimeCheckConnection = 0;
        static string urlpath;
        // unique Uri's queue
        private Queue queueURLS;
        // thread that take the browse editor text to parse it
        private Thread threadParse;
        // binary tree to keep unique Uri's
        private SortTree urlStorage;
        // Performance Counter to measure CPU usage
        private System.Diagnostics.PerformanceCounter cpuCounter;
        // Performance Counter to measure memory usage
        private System.Diagnostics.PerformanceCounter ramCounter;

        // number of bytes downloaded
        private int nByteCount;
        private int ByteCount
        {
            get
            {
                return nByteCount;
            }
            set
            {
                nByteCount = value;
                panelbytecount(ByteCount / 1024 + 1);
            }
        }

        private delegate void Panelbytecountdelegate(int count);
        public void panelbytecount(int count)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new Panelbytecountdelegate(panelbytecount), new object[] { count });
                return;
            }
            this.statusBarPanelByteCount.Text = Commas(count) + " KB";


        }

        // number of errors during the download process
        private int nErrorCount;
        private int ErrorCount
        {
            get
            {
                return nErrorCount;
            }
            set
            {
                nErrorCount = value;
                appenedtostatuserrorcount(nErrorCount);
            }
        }

        //for errors
        private delegate void appendstatuserrors(int errors);
        private void appenedtostatuserrorcount(int errorscount)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new appendstatuserrors(appenedtostatuserrorcount), new
                object[] { errorscount }); // <<<<<<<<<THIS IS WHERE IT ERRORS OUT.
                return;
            }
            statusBarPanelErrors.Text = Commas(nErrorCount) + " errors";

        }

        //urcount
        private delegate void appendurlcount(int nURLCount);
        private void appenedURLCount(int nURLCount)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new appendurlcount(appenedURLCount), new
                object[] { nURLCount }); // <<<<<<<<<THIS IS WHERE IT ERRORS OUT.
                return;
            }
            this.statusBarPanelURLs.Text = Commas(nURLCount) + " URL found";

        }

        private delegate void appendfilecount(int nFileCount);
        private void appenedFileCount(int nFileCount)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new appendfilecount(appenedFileCount), new
                object[] { nFileCount }); // <<<<<<<<<THIS IS WHERE IT ERRORS OUT.
                return;
            }
            this.statusBarPanelFiles.Text = Commas(nFileCount) + " file(s) downloaded";


        }



        // number of Uri's found
        private int nURLCount;
        private int URLCount
        {
            get
            {
                return nURLCount;
            }
            set
            {
                nURLCount = value;
                appenedURLCount(nURLCount);
            }
        }

        // available memory
        private float nFreeMemory;
        private float FreeMemory
        {
            get { return nFreeMemory; }
            set
            {
                nFreeMemory = value;
                statusBarPanelMem.Text = nFreeMemory + " Mb Available";
            }
        }

        // CPU usage
        private int nCPUUsage;
        private int CPUUsage
        {
            get { return nCPUUsage; }
            set
            {
                nCPUUsage = value;
                statusBarPanelCPU.Text = "CPU usage " + nCPUUsage + "%";

                Icon icon = Icon.FromHandle(((Bitmap)imageListPercentage.Images[value / 10]).GetHicon());
                statusBarPanelCPU.Icon = icon;
            }
        }

        // download folder
        private string strDownloadfolder;
        private string Downloadfolder
        {
            get { return strDownloadfolder; }
            set
            {
                strDownloadfolder = value;
                strDownloadfolder = strDownloadfolder.TrimEnd('\\');
            }
        }

        // number of files downloaded
        private int nFileCount;
        private int FileCount
        {
            get { return nFileCount; }
            set
            {
                nFileCount = value;

                appenedFileCount(nFileCount);
            }
        }

        // threads array
        private Thread[] threadsRun;

        // number of running threads
        private int nThreadCount;
        private int ThreadCount
        {
            get { return nThreadCount; }
            set
            {
                Monitor.Enter(this.listViewThreads);
                try
                {
                    for (int nIndex = 0; nIndex < value; nIndex++)
                    {
                        // check if thread not created or not suspended
                        if (threadsRun[nIndex] == null || threadsRun[nIndex].ThreadState != ThreadState.Suspended)
                        {
                            //if (threadsRun[nIndex] != null)
                            //{
                            //    threadsRun[nIndex].Abort();
                            //}
                            // create new thread
                            threadsRun[nIndex] = new Thread(new ThreadStart(ThreadRunFunction));
                            // set thread name equal to its index
                            threadsRun[nIndex].Name = nIndex.ToString();
                            // start thread working function
                            threadsRun[nIndex].Start();
                            // check if thread dosn't added to the view
                            if (nIndex == listViewThreads.Items.Count)
                            {
                                // add a new line in the view for the new thread
                                ListViewItem item = listViewThreads.Items.Add((nIndex + 1).ToString(), 0);
                                string[] subItems = { "", "", "", "0", "0%" };
                                item.SubItems.AddRange(subItems);
                            }
                        }
                        // check if the thread is suspended
                        else if (threadsRun[nIndex].ThreadState == ThreadState.Suspended)
                        {
                            // get thread item from the list
                            ListViewItem item = this.listViewThreads.Items[nIndex];
                            //item.ImageIndex = 1;
                            item.SubItems[2].Text = "Resume";
                            // resume the thread
                            threadsRun[nIndex].Resume();
                        }
                    }
                    // change thread value
                    nThreadCount = value;
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.ToString());
                }
                Monitor.Exit(this.listViewThreads);
            }
        }

        // MIME types string
        private string strMIMETypes = GetMIMETypes();
        private string MIMETypes
        {
            get
            {
                return strMIMETypes;
            }
            set
            {
                strMIMETypes = value;
            }
        }

        // encoding text that includes all settings types in one string
        private Encoding encoding = GetTextEncoding();
        private Encoding TextEncoding
        {
            get
            {
                return encoding;
            }
            set
            {
                encoding = value;
            }
        }

        // timeout of sockets send and receive
        private int nRequestTimeout;
        private int RequestTimeout
        {
            get
            {
                return nRequestTimeout;
            }
            set
            {
                nRequestTimeout = value;
            }
        }

        // the time that each thread sleeps when the refs queue empty
        private int nSleepFetchTime;
        private int SleepFetchTime
        {
            get
            {
                return nSleepFetchTime;
            }
            set
            {
                nSleepFetchTime = value;
            }
        }

        // List of a user defined list of restricted words to enable user to prevent any bad pages 
        private string[] strExcludeWords;
        private string[] ExcludeWords
        {
            get
            {
                return strExcludeWords;
            }
            set
            {
                strExcludeWords = value;
            }
        }

        // List of a user defined list of restricted files extensions to avoid paring non-text data 
        private string[] strExcludeFiles;
        private string[] ExcludeFiles
        {
            get
            {
                return strExcludeFiles;
            }
            set
            {
                strExcludeFiles = value;
            }
        }

        // List of a user defined list of restricted hosts extensions to avoid blocking by these hosts
        private string[] strExcludeHosts;
        private string[] ExcludeHosts
        {
            get
            {
                return strExcludeHosts;
            }
            set
            {
                strExcludeHosts = value;
            }
        }

        // the number of requests to keep in the requests view for review requests details
        private int nLastRequestCount;
        private int LastRequestCount
        {
            get
            {
                return nLastRequestCount;
            }
            set
            {
                nLastRequestCount = value;
            }
        }

        // the time that each thread sleep after handling any request, 
        // which is very important value to prevent Hosts from blocking the crawler due to heavy load
        private int nSleepConnectTime;
        private int SleepConnectTime
        {
            get
            { return nSleepConnectTime; }
            set { nSleepConnectTime = value; }
        }

        // represents the depth of navigation in the crawling process
        private int nWebDepth;
        private int WebDepth
        {
            get { return nWebDepth; }
            set { nWebDepth = value; }
        }

        // MIME types are the types that are supported to be downloaded by the crawler 
        // and the crawler includes a default types to be used. 
        private bool bAllMIMETypes;
        private bool AllMIMETypes
        {
            get { return bAllMIMETypes; }
            set { bAllMIMETypes = value; }
        }

        // to limit crawling process to the same host of the original URL
        private bool bKeepSameServer;
        private bool KeepSameServer
        {
            get { return bKeepSameServer; }
            set { bKeepSameServer = value; }
        }

        // means keep socket connection opened for subsequent requests to avoid reconnect time
        private bool bKeepAlive;
        private bool KeepAlive
        {
            get { return bKeepAlive; }
            set { bKeepAlive = value; }
        }

        // flag to be used to stop all running threads when user request to stop
        bool ThreadsRunning;

        #endregion

        public MainForm()
        {
            InitializeComponent();
            this.urlStorage = new SortTree();
            this.threadsRun = new Thread[200];
            this.queueURLS = new Queue();
            this.cpuCounter = new System.Diagnostics.PerformanceCounter();
            this.ramCounter = new System.Diagnostics.PerformanceCounter("Memory", "Available MBytes");

            this.cpuCounter.CategoryName = "Processor";
            this.cpuCounter.CounterName = "% Processor Time";
            this.cpuCounter.InstanceName = "_Total";
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            statusBarPanelInfo.Text = InternetGetConnectedStateString();
            InitValues();
        }



        [DllImport("wininet")]
        public static extern int InternetGetConnectedState(ref int lpdwFlags, int dwReserved);
        [DllImport("wininet")]
        public static extern int InternetAutodial(int dwFlags, int hwndParent);

        /// <summary>
        /// get connected with connection string.
        /// </summary>
        /// <returns></returns>
        string InternetGetConnectedStateString()
        {
            string strState = "";
            try
            {
                int nState = 0;
                // check internet connection state
                if (InternetGetConnectedState(ref nState, 0) == 0)
                    return "You are currently not connected to the internet";
                if ((nState & 1) == 1)
                    strState = "Modem connection";
                else if ((nState & 2) == 2)
                    strState = "LAN connection";
                else if ((nState & 4) == 4)
                    strState = "Proxy connection";
                else if ((nState & 8) == 8)
                    strState = "Modem is busy with a non-Internet connection";
                else if ((nState & 0x10) == 0x10)
                    strState = "Remote Access Server is installed";
                else if ((nState & 0x20) == 0x20)
                    return "Offline";
                else if ((nState & 0x40) == 0x40)
                    return "Internet connection is currently configured";

                // get current machine IP
                IPHostEntry he = Dns.Resolve(Dns.GetHostName());
                strState += ",  Machine IP: " + he.AddressList[0].ToString();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            return strState;
        }


        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        static Encoding GetTextEncoding()
        {
            Encoding code;
            if (Settings.GetValue("Use windows default code page", true) == true)
                code = Encoding.Default;
            else
            {
                string strCodePage = Settings.GetValue("Settings code page");
                Regex reg = new Regex(@"\([0-9]*\)");
                strCodePage = reg.Match(strCodePage).Value;
                code = Encoding.GetEncoding(int.Parse(strCodePage.Trim('(', ')')));
            }
            return code;
        }

        /// <summary>
        /// establishing communication with intenet.
        /// </summary>

        void ConnectionInfo()
        {
            try
            {
                int nState = 0;
                if (InternetGetConnectedState(ref nState, 0) == 0)
                {
                    if (nFirstTimeCheckConnection++ == 0)
                        // ask for dial up or DSL connection
                        if (InternetAutodial(1, 0) != 0)
                            // check internet connection state again
                            InternetGetConnectedState(ref nState, 0);
                }
                if ((nState & 2) == 2 || (nState & 4) == 4)
                    // reset to reask for connection agina
                    nFirstTimeCheckConnection = 0;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            statusBarPanelInfo.Text = InternetGetConnectedStateString();
        }

        // construct MIME types string from settings xml file
        static string GetMIMETypes()
        {
            string str = "";
            // check for settings xml file existence
            if (File.Exists(Application.StartupPath + "\\Settings.xml"))
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(Application.StartupPath + "\\Settings.xml");
                XmlNode element = doc.DocumentElement.SelectSingleNode("SettingsForm-listViewFileMatches");
                if (element != null)
                {
                    for (int n = 0; n < element.ChildNodes.Count; n++)
                    {
                        XmlNode xmlnode = element.ChildNodes[n];
                        XmlAttribute attribute = xmlnode.Attributes["Checked"];
                        if (attribute == null || attribute.Value.ToLower() != "true")
                            continue;
                        string[] items = xmlnode.InnerText.Split('\t');
                        if (items.Length > 1)
                        {
                            str += items[0];
                            if (items.Length > 2)
                                str += '[' + items[1] + ',' + items[2] + ']';
                            str += ';';
                        }
                    }
                }
            }
            return str;
        }





        /// <summary>
        /// 
        /// </summary>
        /// <param name="nSelectedIndex"></param>
        void ShowSettings(int nSelectedIndex)
        {
            SettingsForm form = new SettingsForm();
            form.SelectedIndex = nSelectedIndex;
            if (form.ShowDialog(this) == DialogResult.OK)
            {
                ThreadCount = Settings.GetValue("Threads count", 10);
                InitValues();
            }
        }
        //private void Btngo_Click(object sender, EventArgs e)
        //{
        //    StartCrawling();

        //}
        ///// <summary>
        ///// 
        ///// </summary>
        //void StartCrawling()
        //{
        //    Btngo.Enabled = false;
        //    // insert combo text in the combo list
        //    if (this.comboBoxWeb.FindStringExact(comboBoxWeb.Text) < 0)
        //        this.comboBoxWeb.Items.Insert(0, this.comboBoxWeb.Text);

        //    urlpath = comboBoxWeb.Text.Trim();
        //    if (threadParse == null || threadParse.ThreadState != ThreadState.Suspended)
        //    {
        //        urlStorage.Clear();

        //        // start parsing thread
        //        threadParse = new Thread(new ThreadStart(RunParser));
        //        threadParse.Start();
        //    }

        //    // update running threads
        //    ThreadCount = Settings.GetValue("Threads count", 10);

        //    toolBarButtonContinue.Enabled = false;
        //    toolBarButtonPause.Enabled = true;
        //}

        private void toolStripButton1_Click(object sender, EventArgs e)
        {

        }
        /// <summary>
        /// to delete all the items this method usefull
        /// </summary>

        void DeleteAllItems()
        {
            if (MessageBox.Show(this, "Do you want to delete all?", "Verify", MessageBoxButtons.YesNo) == DialogResult.Yes)
            {
                this.listViewErrors.Items.Clear();
                this.listViewRequests.Items.Clear();
                this.urlStorage = new SortTree();
                this.URLCount = 0;
                this.FileCount = 0;
                this.ByteCount = 0;
                this.ErrorCount = 0;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="nNum"></param>
        /// <returns></returns>

        string Commas(int nNum)
        {
            string str = nNum.ToString();
            int nIndex = str.Length;
            while (nIndex > 3)
            {
                str = str.Insert(nIndex - 3, ",");
                nIndex -= 3;
            }
            return str;
        }

        private void timerConnectionInfo_Tick(object sender, EventArgs e)
        {
            ConnectionInfo();
        }

        private void timerMem_Tick(object sender, EventArgs e)
        {
            FreeMemory = ramCounter.NextValue();
            CPUUsage = (int)cpuCounter.NextValue();
        }

        private void menuItemExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void menuItemSettings_Click(object sender, EventArgs e)
        {
            ShowSettings(-1);
        }

        private void menuItemFileMatches_Click(object sender, EventArgs e)
        {
            ShowSettings(0);
        }

        private void menuItemOutput_Click(object sender, EventArgs e)
        {
            ShowSettings(2);
        }




        void ContinueParsing()
        {
            if (threadParse == null)
                return;
            if (threadParse.ThreadState == ThreadState.Suspended)
                threadParse.Resume();

            // update runnning threads
            ThreadCount = Settings.GetValue("Threads count", 10);

            ToggleToolBarButtonContinue(false);
            ToggleToolBarButtonPause(true);
        }

        // pause all working threads
        void PauseParsing()
        {
            if (threadParse.ThreadState == ThreadState.Running)
                threadParse.Suspend();
            for (int n = 0; n < ThreadCount; n++)
            {
                Thread thread = this.threadsRun[n];
                if (thread.ThreadState == ThreadState.Running)
                    thread.Suspend();
            }
            ToggleToolBarButtonContinue(true);
            ToggleToolBarButtonPause(false);
        }

        // abort all working threads
        void RunParser()
        {
            ThreadsRunning = true;
            string strUri = urlpath;
            try
            {

                //string strUri = cmbmethodtoget();
                //strUri = urlpath;
                if (Directory.Exists(strUri) == true)
                    ParseFolder(strUri, 0);
                else
                {
                    if (File.Exists(strUri) == false)
                    {
                        Normalize(ref strUri);

                    }
                    MyUri uri = new MyUri(strUri);
                    cmbmethodtoget(strUri);
                    this.EnqueueUri(uri, false);
                }
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
                //LogError(this.comboBoxWeb.Text, e.Message);
                //return;
            }

            ToggleToolBarButtonContinue(false);
            ToggleButtonGo(true);
        }

        private delegate void ToggleToolBarButtonContinueCallBack(bool flag);
        private void ToggleToolBarButtonContinue(bool flag)
        {
            if (this.toolbarMain.InvokeRequired)
            {
                this.BeginInvoke(new ToggleToolBarButtonContinueCallBack(ToggleToolBarButtonContinue), new
                object[] { flag });
                return;
            }

            this.toolBarButtonContinue.Enabled = flag;
        }

        private delegate void ToggleToolBarButtonPauseCallBack(bool flag);
        private void ToggleToolBarButtonPause(bool flag)
        {
            if (this.toolbarMain.InvokeRequired)
            {
                this.BeginInvoke(new ToggleToolBarButtonPauseCallBack(ToggleToolBarButtonPause), new
                object[] { flag });
                return;
            }

            this.toolBarButtonPause.Enabled = flag;
        }

        private delegate void ToggleButtonGoCallBack(bool flag);
        private void ToggleButtonGo(bool flag)
        {
            if (this.buttonGo.InvokeRequired)
            {
                this.BeginInvoke(new ToggleButtonGoCallBack(ToggleButtonGo), new
                object[] { flag }); 
                return;
            }

            this.buttonGo.Enabled = flag;

        }

        //delegate FOR AVOIDING CRoss thread operation
        private delegate void cmburlpath(string UrlPath);
        private void cmbmethodtoget(string UrlPath)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new cmburlpath(cmbmethodtoget), new
                object[] { UrlPath }); // <<<<<<<<<THIS IS WHERE IT ERRORS OUT.
                return;
            }

            comboBoxWeb.Text = UrlPath;

        }

        // abort all working threads
        void StopParsing()
        {
            this.queueURLS.Clear();
            ThreadsRunning = false;
            Thread.Sleep(500);
            try
            {
                if (threadParse.ThreadState == ThreadState.Suspended)
                    threadParse.Resume();
                threadParse.Abort();
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            Monitor.Enter(this.listViewThreads);
            for (int n = 0; n < ThreadCount; n++)
            {
                try
                {
                    Thread thread = this.threadsRun[n];
                    ListViewItem itemLog = this.listViewThreads.Items[int.Parse(thread.Name)];
                    itemLog.SubItems[2].Text = "Stop";
                    itemLog.BackColor = Color.White;
                    //itemLog.ImageIndex = 3;
                    if (thread != null && thread.IsAlive)
                    {
                        if (thread.ThreadState == ThreadState.Suspended)
                            thread.Resume();
                        thread.Abort();
                    }
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.ToString());
                }
            }
            Monitor.Exit(this.listViewThreads);
            toolBarButtonContinue.Enabled = true;
            toolBarButtonPause.Enabled = false;
            buttonGo.Enabled = true;

            queueURLS.Clear();
            urlStorage.Clear();
        }

        void ThreadRunFunction()
        {
            MyWebRequest request = null;
            while (ThreadsRunning && int.Parse(Thread.CurrentThread.Name) < ThreadCount)
            {
                MyUri uri = DequeueUri();
                if (uri != null)
                {
                    if (SleepConnectTime > 0)
                        Thread.Sleep(SleepConnectTime * 1000);
                    ParseUri(uri, ref request);
                }
                else
                    Thread.Sleep(SleepFetchTime * 1000);
            }

            Monitor.Enter(this.listViewThreads);
            try
            {

                if (ThreadsRunning == false)
                {
                    SetSubItemText(int.Parse(Thread.CurrentThread.Name), "Stop");
                    //ListViewItem item = this.listViewThreads.Items[int.Parse(Thread.CurrentThread.Name)];
                    //item.SubItems[2].Text = "Stop";
                }
                //item.ImageIndex = 0;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            Monitor.Exit(this.listViewThreads);
        }

        private delegate void SetSubItemTextCallBack(int index, string text);
        private void SetSubItemText(int index, string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.listViewThreads.InvokeRequired)
            {
                SetSubItemTextCallBack d = new SetSubItemTextCallBack(SetSubItemText);
                this.BeginInvoke(d, new object[] { index, text });
            }
            else
            {
                ListViewItem item = this.listViewThreads.Items[index];
                item.SubItems[2].Text = text;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="strURL"></param>
        private void Normalize(ref string strURL)
        {
            if (strURL.StartsWith("http://") == false)
                strURL = "http://" + strURL;
            if (strURL.IndexOf("/", 8) == -1)
                strURL += '/';
        }


        #region deleagtes
        //cross thread operation fixing delegate 
        public ListViewItem itemLog = null;
        private delegate void RunListViewDelegate(string depth, int index, string uri, int threadName);
        public void RunListView(string depth, int index, string uril, int threadName)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new RunListViewDelegate(RunListView), new object[] { depth, index, uril, threadName });
                return;
            }
            itemLog = ReturnListItemByThreadId(threadName);//Convert.ToInt32(Thread.CurrentThread.Name);

            itemLog.SubItems[1].Text = depth;
            //itemLog.ImageIndex = 1;
            itemLog.BackColor = Color.White;
            // initialize status to Connect
            itemLog.SubItems[2].Text = "Connect";
            itemLog.ForeColor = Color.Blue;
            itemLog.SubItems[3].Text = uril;
            itemLog.SubItems[4].Text = "";
            itemLog.SubItems[5].Text = "";
        }


        private delegate void RunListViewstaticDelegate(ListViewItem item);
        /// <summary>
        /// clears the thread view's current thread row.
        /// </summary>
        /// <param name="item"></param>
        public void RunListViewStatic(ListViewItem item)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new RunListViewstaticDelegate(RunListViewStatic), new object[] { item });
                return;
            }

            item.SubItems[1].Text = "";
            //item.ImageIndex = 0;
            item.BackColor = Color.WhiteSmoke;
            item.ForeColor = Color.Black;
            item.SubItems[2].Text = "";
            item.SubItems[3].Text = "";
            item.SubItems[4].Text = "";
            item.SubItems[5].Text = "";



        }

        private delegate void ListviewDelegate(int count, int threadName);
        public void RunListViewStatic(int count,int threadName)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new ListviewDelegate(RunListViewStatic), new object[] { count, threadName });
                return;
            }
            itemLog = ReturnListItemByThreadId(threadName); 

            itemLog.SubItems[4].Text = Commas(count);
        }

        private delegate void ListviewDelegate2(string temp, int threadName);
        public void RunListViewStatic(string temp, int threadName)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new ListviewDelegate2(RunListViewStatic), new object[] { temp, threadName });
                return;
            }
            itemLog = ReturnListItemByThreadId(threadName); 

            itemLog.SubItems[5].Text = temp;




        }

        //itemLog.SubItems[2].Text = "Download";
        //        itemLog.ForeColor = Color.Black;
        private delegate void ListviewDelegate3(int threadName);
        public void RunListViewStatic(int threadName)
        {
            if (this.InvokeRequired)
            {
                this.BeginInvoke(new ListviewDelegate3(RunListViewStatic), new object[] {threadName });
                return;
            }
            itemLog = ReturnListItemByThreadId(threadName); 

            itemLog.SubItems[2].Text = "Download";
            itemLog.ForeColor = Color.Black;



        }


        //private ListViewItem lstvieitemtemp = null;
        //public ListViewItem returnlistfind
        //{
        //    set
        //    {
        //        lstvieitemtemp = value;
        //    }
        //    get
        //    {
        //        return listViewThreads.Items[Convert.ToInt32(Thread.CurrentThread.Name)];
        //    }
        //}



        public ListViewItem ReturnListItemByThreadId(int threadName)
        {
            return listViewThreads.Items[threadName];
        }

        #endregion




        void LogCell(ref ListViewItem itemLog, int nCell, string str)
        {
            Monitor.Enter(this.listViewThreads);
            try
            {
                itemLog.SubItems[nCell].Text = str;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            Monitor.Exit(this.listViewThreads);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="uri"></param>
        /// <param name="request"></param>
        void ParseUri(MyUri uri, ref MyWebRequest request)
        {
            string strStatus = "";
            // check if connection is kept alive from previous connections or not
            if (request != null && request.response.KeepAlive)
                strStatus += "Connection live to: " + uri.Host + "\r\n\r\n";
            else
                strStatus += "Connecting: " + uri.Host + "\r\n\r\n";

            //ListViewItem itemLog = null;
            Monitor.Enter(this.listViewThreads);
            try
            {
                int nDepth = uri.Depth;
                int i = 1;
                // update thread information in the threads view list
                RunListView(nDepth.ToString(), i, uri.AbsoluteUri, Convert.ToInt32(Thread.CurrentThread.Name));
                //itemLog = this.listViewThreads.Items[Convert.ToInt32(Thread.CurrentThread.Name)];


                //itemLog.SubItems[1].Text = nDepth.ToString();
                //itemLog.ImageIndex = 1;
                //itemLog.BackColor = Color.WhiteSmoke;
                //// initialize status to Connect
                //itemLog.SubItems[2].Text = "Connect";
                //itemLog.ForeColor = Color.Red;
                //itemLog.SubItems[3].Text = uri.AbsoluteUri;
                //itemLog.SubItems[4].Text = "";
                //itemLog.SubItems[5].Text = "";
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            Monitor.Exit(this.listViewThreads);

            try
            {
                // create web request
                request = MyWebRequest.Create(uri, request, KeepAlive);
                // set request timeout
                request.Timeout = RequestTimeout * 1000;
                // retrieve response from web request
                MyWebResponse response = request.GetResponse();
                // update status text with the request and response headers
                strStatus += request.Header + response.Header;

                // check for redirection
                if (response.ResponseUri.Equals(uri) == false)
                {
                    // add the new uri to the queue
                    this.EnqueueUri(new MyUri(response.ResponseUri.AbsoluteUri), true);
                    // update status
                    strStatus += "Redirected to: " + response.ResponseUri + "\r\n";
                    // log current uri status
                    LogUri(uri.AbsoluteUri, strStatus);
                    // reset current request to avoid response socket opening case
                    request = null;
                    return;
                }

                // check for allowed MIME types
                if (AllMIMETypes == false && response.ContentType != null && MIMETypes.Length > 0)
                {
                    string strContentType = response.ContentType.ToLower();
                    int nExtIndex = strContentType.IndexOf(';');
                    if (nExtIndex != -1)
                        strContentType = strContentType.Substring(0, nExtIndex);
                    if (strContentType.IndexOf('*') == -1 && (nExtIndex = MIMETypes.IndexOf(strContentType)) == -1)
                    {
                        LogError(uri.AbsoluteUri, strStatus + "\r\nUnlisted Content-Type (" + strContentType + "), check settings.");
                        request = null;
                        return;
                    }
                    // find numbers
                    Match match = new Regex(@"\d+").Match(MIMETypes, nExtIndex);
                    int nMin = int.Parse(match.Value) * 1024;
                    match = match.NextMatch();
                    int nMax = int.Parse(match.Value) * 1024;
                    if (nMin < nMax && (response.ContentLength < nMin || response.ContentLength > nMax))
                    {
                        LogError(uri.AbsoluteUri, strStatus + "\r\nContentLength limit error (" + response.ContentLength + ")");
                        request = null;
                        return;
                    }
                }

                // check for response extention
                string[] ExtArray = { ".gif", ".jpg", ".css", ".zip", ".exe" };
                bool bParse = true;
                foreach (string ext in ExtArray)
                    if (uri.AbsoluteUri.ToLower().EndsWith(ext) == true)
                    {
                        bParse = false;
                        break;
                    }

                if (ExcludeFiles != null)
                {
                    foreach (string ext in ExcludeFiles)
                        if (ext.Trim().Length > 0 && uri.AbsoluteUri.ToLower().EndsWith(ext) == true)
                        {
                            bParse = false;
                            break;
                        }
                }

                // construct path in the hard disk
                string strLocalPath = uri.LocalPath;
                // check if the path ends with / to can crate the file on the HD 
                if (strLocalPath.EndsWith("/") == true)
                    // check if there is no query like (.asp?i=32&j=212)
                    if (uri.Query == "")
                        // add a default name for / ended pathes
                        strLocalPath += "default.html";
                // check if the uri includes a query string
                if (uri.Query != "")
                    // construct the name from the query hash value to be the same if we download it again
                    strLocalPath += uri.Query.GetHashCode() + ".html";
                // construct the full path folder
                string BasePath = this.Downloadfolder + "\\" + uri.Host + Path.GetDirectoryName(uri.AbsolutePath);
                // check if the folder not found
                if (Directory.Exists(BasePath) == false)
                    // create the folder
                    Directory.CreateDirectory(BasePath);
                // construct the full path name of the file
                string PathName = this.Downloadfolder + "\\" + uri.Host + strLocalPath.Replace("%20", " ");
                // open the output file
                FileStream streamOut = File.Open(PathName, FileMode.Create, FileAccess.Write, FileShare.ReadWrite);
                BinaryWriter writer = new BinaryWriter(streamOut);

                //calling delegate for this method
                RunListViewStatic(Convert.ToInt32(Thread.CurrentThread.Name));
                // receive response buffer
                string strResponse = "";
                byte[] RecvBuffer = new byte[10240];
                int nBytes, nTotalBytes = 0;
                // loop to receive response buffer
                while ((nBytes = response.socket.Receive(RecvBuffer, 0, 10240, SocketFlags.None)) > 0)
                {
                    // increment total received bytes
                    nTotalBytes += nBytes;
                    // write received buffer to file
                    writer.Write(RecvBuffer, 0, nBytes);
                    // check if the uri type not binary to can be parsed for refs
                    if (bParse == true)
                        // add received buffer to response string
                        strResponse += Encoding.ASCII.GetString(RecvBuffer, 0, nBytes);
                    // update view text
                    RunListViewStatic(nTotalBytes, Convert.ToInt32(Thread.CurrentThread.Name));
                    //itemLog.SubItems[4].Text = Commas(nTotalBytes);
                    if (response.ContentLength > 0)
                        RunListViewStatic('%' + (100 - (response.ContentLength - nTotalBytes) * 100 / response.ContentLength).ToString(), Convert.ToInt32(Thread.CurrentThread.Name));
                    //itemLog.SubItems[5].Text = '%' + (100 - (response.ContentLength - nTotalBytes) * 100 / response.ContentLength).ToString();
                    // check if connection Keep-Alive to can break the loop if response completed
                    if (response.KeepAlive && nTotalBytes >= response.ContentLength && response.ContentLength > 0)
                        break;
                }
                // close output stream
                writer.Close();
                streamOut.Close();

                if (response.KeepAlive)
                    strStatus += "Connection kept alive to be used in subpages.\r\n";
                else
                {
                    // close response
                    response.Close();
                    strStatus += "Connection closed.\r\n";
                }
                // update status
                strStatus += Commas(nTotalBytes) + " bytes, downloaded to \"" + PathName + "\"\r\n";
                // increment total file count
                FileCount++;
                // increment total bytes count
                ByteCount += nTotalBytes;

                if (ThreadsRunning == true && bParse == true && uri.Depth < WebDepth)
                {
                    strStatus += "\r\nParsing page ...\r\n";

                    if (ExcludeWords != null)
                    {
                        // check for restricted words
                        foreach (string strExcludeWord in ExcludeWords)
                            if (strExcludeWord.Trim().Length > 0 && strResponse.IndexOf(strExcludeWord) != -1)
                            {
                                LogError(uri.AbsoluteUri, strStatus + "\r\nPage includes reserved word (" + strExcludeWord + ")");
                                EraseItem(Convert.ToInt32(Thread.CurrentThread.Name));
                                File.Delete(PathName);
                                return;
                            }
                    }

                    // parse the page to search for refs
                    string strRef = @"(href|HREF|src|SRC)[ ]*=[ ]*[""'][^""'#>]+[""']";
                    MatchCollection matches;
                    matches = new Regex(strRef).Matches(strResponse);
                    strStatus += "Found: " + matches.Count + " ref(s)\r\n";
                    URLCount += matches.Count;
                    foreach (Match match in matches)
                    {
                        strRef = match.Value.Substring(match.Value.IndexOf('=') + 1).Trim('"', '\'', '#', ' ', '>');
                        try
                        {
                            if (strRef.IndexOf("..") != -1 || strRef.StartsWith("/") == true || strRef.StartsWith("http://") == false)
                                strRef = new Uri(uri, strRef).AbsoluteUri;
                            Normalize(ref strRef);
                            MyUri newUri = new MyUri(strRef);
                            if (newUri.Scheme != Uri.UriSchemeHttp && newUri.Scheme != Uri.UriSchemeHttps)
                                continue;
                            if (newUri.Host != uri.Host && KeepSameServer == true)
                                continue;
                            newUri.Depth = uri.Depth + 1;
                            if (this.EnqueueUri(newUri, true) == true)
                                strStatus += newUri.AbsoluteUri + "\r\n";
                        }
                        catch (Exception e)
                        {
                            //MessageBox.Show(e.ToString());
                        }
                    }
                }
                LogUri(uri.AbsoluteUri, strStatus);
            }
            catch (Exception e)
            {
                LogError(uri.AbsoluteUri, strStatus + e.Message);
                request = null;
            }
            finally
            {
                EraseItem(Convert.ToInt32(Thread.CurrentThread.Name));
            }
        }

        delegate void EraseItemCallBack(int threadName);
        void EraseItem(int threadName)
        {
            if (this.listViewThreads.InvokeRequired)
            {
                EraseItemCallBack d = new EraseItemCallBack(EraseItem);
                this.BeginInvoke(d, new object[] { threadName });
            }
            else
            {
                Monitor.Enter(this.listViewThreads);
                try
                {
                    RunListViewStatic(ReturnListItemByThreadId(threadName));
                }
                finally
                {
                    Monitor.Exit(this.listViewThreads);
                }
            }
        }

        void LogUri(string strHead, string strBody)
        {
            if (LastRequestCount > 0)
            {
                // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
                if (this.listViewRequests.InvokeRequired)
                {
                    LogUriCallBack d = new LogUriCallBack(LogUri);
                    this.BeginInvoke(d, new object[] { strHead, strBody });
                }
                else
                {
                    Monitor.Enter(this.listViewRequests);
                    try
                    {
                        ListViewItem item = this.listViewRequests.Items.Insert(0, DateTime.Now.ToString());
                        item.SubItems.AddRange(new String[] { strHead, strBody });
                        while (this.listViewRequests.Items.Count > LastRequestCount)
                            this.listViewRequests.Items.RemoveAt(this.listViewRequests.Items.Count - 1);
                    }
                    catch (Exception e)
                    {
                        MessageBox.Show(e.ToString());
                    }
                    Monitor.Exit(this.listViewRequests);
                }
            }
        }



        bool AddURL(ref MyUri uri)
        {
            if (ExcludeHosts != null)
            {
                foreach (string str in ExcludeHosts)
                    if (str.Trim().Length > 0 && uri.Host.ToLower().IndexOf(str.Trim()) != -1)
                    {
                        LogError(uri.AbsoluteUri, "\r\nHost excluded as it includes reserved pattern (" + str + ")");
                        return false;
                    }
            }
            Monitor.Enter(urlStorage);
            bool bNew = false;
            try
            {
                string strURL = uri.AbsoluteUri;
                bNew = urlStorage.Add(ref strURL).Count == 1;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            Monitor.Exit(urlStorage);

            return bNew;
        }

        void LogError(string strHead, string strBody)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.listViewErrors.InvokeRequired)
            {
                LogErrorCallBack d = new LogErrorCallBack(LogError);
                this.BeginInvoke(d, new object[] { strHead, strBody });
            }
            else
            {

                Monitor.Enter(this.listViewErrors);
                try
                {
                    ListViewItem item = this.listViewErrors.Items.Add((ErrorCount + 1).ToString());
                    item.SubItems.AddRange(new String[] { DateTime.Now.ToString(), strHead, strBody });
                    while (this.listViewErrors.Items.Count > 1000)
                        this.listViewErrors.Items.RemoveAt(0);
                }
                catch (Exception e)
                {
                    MessageBox.Show(e.ToString());
                }
                Monitor.Exit(this.listViewErrors);
                ErrorCount++;
            }
        }

        private delegate void LogErrorCallBack(string strHead, string strBody);
        private delegate void LogUriCallBack(string strHead, string strBody);        


        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        MyUri DequeueUri()
        {
            //MyWebRequest request = null;
            Monitor.Enter(queueURLS);
            MyUri uri = null;
            try
            {
                uri = (MyUri)queueURLS.Dequeue();
                //if (uri == null)
                //{
                //    ParseUri(urlpath, request);
                //}
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
            }
            Monitor.Exit(queueURLS);

            return uri;
        }

        // push uri to the queue
        bool EnqueueUri(MyUri uri, bool bCheckRepetition)
        {

            // add the uri to the binary tree to check if it is duplicated or not
            if (bCheckRepetition == true && AddURL(ref uri) == false)
                return false;

            Monitor.Enter(queueURLS);
            try
            {
                // add the uri to the queue
                queueURLS.Enqueue(uri);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            Monitor.Exit(queueURLS);

            return true;
        }

        // pop uri from the queue


        void ParseFolder(string folderName, int nDepth)
        {
            DirectoryInfo dir = new DirectoryInfo(folderName);
            FileInfo[] fia = dir.GetFiles("*.txt");
            foreach (FileInfo f in fia)
            {
                if (ThreadsRunning == false)
                    break;
                MyUri uri = new MyUri(f.FullName);
                uri.Depth = nDepth;
                this.EnqueueUri(uri, true);
            }

            DirectoryInfo[] dia = dir.GetDirectories();
            foreach (DirectoryInfo d in dia)
            {
                if (ThreadsRunning == false)
                    break;
                ParseFolder(d.FullName, nDepth + 1);
            }
        }

        // push uri to the queue

        void InitValues()
        {
            WebDepth = Settings.GetValue("Web depth", 3);
            RequestTimeout = Settings.GetValue("Request timeout", 20);
            SleepFetchTime = Settings.GetValue("Sleep fetch time", 2);
            SleepConnectTime = Settings.GetValue("Sleep connect time", 1);
            KeepSameServer = Settings.GetValue("Keep same URL server", false);
            AllMIMETypes = Settings.GetValue("Allow all MIME types", true);
            KeepAlive = Settings.GetValue("Keep connection alive", true);
            ExcludeHosts = Settings.GetValue("Exclude Hosts", ".org; .gov;").Replace("*", "").ToLower().Split(';');
            ExcludeWords = Settings.GetValue("Exclude words", "").Split(';');
            ExcludeFiles = Settings.GetValue("Exclude files", "").Replace("*", "").ToLower().Split(';');
            LastRequestCount = Settings.GetValue("View last requests count", 20);
            Downloadfolder = Settings.GetValue("Download folder", System.Environment.GetFolderPath(System.Environment.SpecialFolder.Personal));
            MIMETypes = GetMIMETypes();
            TextEncoding = GetTextEncoding();
        }

        private void toolbarMain_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
        {
            if (e.Button == this.toolBarButtonContinue)
                ContinueParsing();
            else if (e.Button == this.toolBarButtonPause)
                PauseParsing();
            else if (e.Button == this.toolBarButtonStop)
                StopParsing();
            else if (e.Button == this.toolBarButtonDeleteAll)
                DeleteAllItems();
        }

        private void buttonGo_Click(object sender, EventArgs e)
        {
            StartParsing();
            //MessageBox.Show("Please click Go again to confirm", "Confirmation", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1);
            Thread.Sleep(200);
            StartParsing();            
        }


        void StartParsing()
        {
            this.buttonGo.Enabled = false;
            // insert combo text in the combo list
            if (this.comboBoxWeb.FindStringExact(this.comboBoxWeb.Text) < 0)
                this.comboBoxWeb.Items.Insert(0, this.comboBoxWeb.Text);

            urlpath = comboBoxWeb.Text.Trim();
            if (threadParse == null || threadParse.ThreadState != ThreadState.Suspended)
            {
                this.urlStorage.Clear();
                // start parsing thread
                threadParse = new Thread(new ThreadStart(RunParser));
                threadParse.Start();
            }

            // update running threads
            ThreadCount = Settings.GetValue("Threads count", 10);

            this.toolBarButtonContinue.Enabled = false;
            this.toolBarButtonPause.Enabled = true;
        }

        private void toolBarWeb_ButtonClick(object sender, ToolBarButtonClickEventArgs e)
        {

        }

        private void menuItemAdvanced_Click(object sender, EventArgs e)
        {
            ShowSettings(3);
        }

        private void menuItemConnections_Click(object sender, EventArgs e)
        {
            ShowSettings(1);
        }

        private void menuItem4_Click(object sender, EventArgs e)
        {
            AboutForm form = new AboutForm();
            form.ShowDialog();
        }

        private void comboBoxWeb_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Return)
            {
                if (threadParse == null || threadParse.ThreadState != ThreadState.Running)
                    StartParsing();
            }
        }



        private void listViewThreads_SelectedIndexChanged(object sender, EventArgs e)
        {           

        }
        private void menuItemCut_Click(object sender, System.EventArgs e)
        {
            Clipboard.SetDataObject(this.comboBoxWeb.SelectedText);
            this.comboBoxWeb.SelectedText = "";
        }

        private void menuItemCopy_Click(object sender, System.EventArgs e)
        {
            Clipboard.SetDataObject(this.comboBoxWeb.SelectedText);
        }

        private void menuItemPaste_Click(object sender, System.EventArgs e)
        {
            IDataObject obj = Clipboard.GetDataObject();
            if (obj != null)
                this.comboBoxWeb.SelectedText = obj.GetData("System.String").ToString();
        }

        private void menuItemDelete_Click(object sender, System.EventArgs e)
        {
            this.comboBoxWeb.SelectedText = "";
        }

        private void listViewRequests_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (this.listViewRequests.SelectedItems.Count == 0)
                return;
            ListViewItem item = this.listViewRequests.SelectedItems[0];
            if (item.SubItems.Count > 2)
                this.textBoxRequest.Text = item.SubItems[2].Text;
        }

        private void menuItemHttp_Click(object sender, System.EventArgs e)
        {
            this.comboBoxWeb.Text = "http://";
        }

        private void menuItemFileBrowse_Click(object sender, System.EventArgs e)
        {
            OnFileBrowse();
        }

        void OnFileBrowse()
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Title = "Select file to parse";
            dlg.Filter = "Text files (*.txt)|*.txt|All files (*.*)|*.*";
            if (dlg.ShowDialog() == DialogResult.OK)
                this.comboBoxWeb.Text = dlg.FileName;
        }



        private void toolBarWeb_ButtonDropDown(object sender, ToolBarButtonClickEventArgs e)
        {
            this.menuItemBrowseHttp = new System.Windows.Forms.MenuItem();
            e.Button.DropDownMenu = new System.Windows.Forms.ContextMenu();
            e.Button.DropDownMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							  this.menuItemBrowseHttp});
            // 
            // menuItemBrowseHttp
            // 
            this.menuItemBrowseHttp.Index = 0;
            this.menuItemBrowseHttp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							   this.menuItemHttp,
																							   this.menuItem5});
            this.menuItemBrowseHttp.Text = "&Http";

            foreach (string item in this.comboBoxWeb.Items)
            {
                try
                {
                    Uri uri = new Uri(item);
                    MenuItem mi = new MenuItem(item, new System.EventHandler(OnBrowse));
                    if (File.Exists(item) == true)
                        e.Button.DropDownMenu.MenuItems[2].MenuItems.Add(mi);
                    else if (Directory.Exists(item) == true)
                        e.Button.DropDownMenu.MenuItems[1].MenuItems.Add(mi);
                    else if (uri.Scheme == Uri.UriSchemeHttp)
                        e.Button.DropDownMenu.MenuItems[0].MenuItems.Add(mi);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
        }
        private void OnBrowse(object sender, System.EventArgs e)
        {
            this.comboBoxWeb.Text = ((MenuItem)sender).Text;
        }

        private void timerConnectionInfo_Tick_1(object sender, EventArgs e)
        {
            ConnectionInfo();

        }
        private void menuItemListClear_Click(object sender, System.EventArgs e)
        {
            switch (this.tabControlRightView.SelectedTab.Text)
            {
                case "Threads":
                    this.listViewThreads.Items.Clear();
                    break;
                case "Requests":
                    this.listViewRequests.Items.Clear();
                    break;
                case "Errors":
                    this.listViewErrors.Items.Clear();
                    break;
            }
        }

        private void menuItemDeleteAll_Click(object sender, EventArgs e)
        {
            DeleteAllItems();
        }

        private void listViewErrors_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.listViewErrors.SelectedItems.Count == 0)
                return;
            ListViewItem item = this.listViewErrors.SelectedItems[0];
            this.textBoxErrorDescription.Text = item.SubItems[3].Text;
        }

        private void menuItem2_Click(object sender, EventArgs e)
        {

        }
    }



    public class MyUri : System.Uri
    {
        public MyUri(string uriString)
            : base(uriString)
        {
        }
        public int Depth;
    }

    public class MyWebRequest
    {
        public MyWebRequest(Uri uri, bool bKeepAlive)
        {
            Headers = new WebHeaderCollection();
            RequestUri = uri;
            Headers["Host"] = uri.Host;
            KeepAlive = bKeepAlive;
            if (KeepAlive)
                Headers["Connection"] = "Keep-Alive";
            Method = "GET";
        }

        public static MyWebRequest Create(Uri uri, MyWebRequest AliveRequest, bool bKeepAlive)
        {
            if (bKeepAlive &&
                AliveRequest != null &&
                AliveRequest.response != null &&
                AliveRequest.response.KeepAlive &&
                AliveRequest.response.socket.Connected &&
                AliveRequest.RequestUri.Host == uri.Host)
            {
                AliveRequest.RequestUri = uri;
                return AliveRequest;
            }
            return new MyWebRequest(uri, bKeepAlive);
        }
        public MyWebResponse GetResponse()
        {
            if (response == null || response.socket == null || response.socket.Connected == false)
            {
                response = new MyWebResponse();
                response.Connect(this);
                response.SetTimeout(Timeout);
            }
            response.SendRequest(this);
            response.ReceiveHeader();
            return response;
        }

        public int Timeout;
        public WebHeaderCollection Headers;
        public string Header;
        public Uri RequestUri;
        public string Method;
        public MyWebResponse response;
        public bool KeepAlive;
    }

    public class MyWebResponse
    {
        public MyWebResponse()
        {
        }
        public void Connect(MyWebRequest request)
        {
            ResponseUri = request.RequestUri;

            socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            IPEndPoint remoteEP = new IPEndPoint(Dns.Resolve(ResponseUri.Host).AddressList[0], ResponseUri.Port);
            socket.Connect(remoteEP);
        }
        public void SendRequest(MyWebRequest request)
        {
            ResponseUri = request.RequestUri;

            request.Header = request.Method + " " + ResponseUri.PathAndQuery + " HTTP/1.0\r\n" + request.Headers;
            socket.Send(Encoding.ASCII.GetBytes(request.Header));
        }
        public void SetTimeout(int Timeout)
        {
            socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.SendTimeout, Timeout * 1000);
            socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReceiveTimeout, Timeout * 1000);
        }
        public void ReceiveHeader()
        {
            //string live = "HTTP/1.0 200 OK \n Date: Sun, 19 Mar 2006 19:38:15 GMT \n Content-Length: 29025 \n Content-Type: text/html \n Expires: Sun, 19 Mar 2006 19:39:15 GMT \n Cache-Control: max-age=60, private \n Connection: keep-alive \n Proxy-Connection: keep-alive \n Server: Apache \n Vary: Accept-Encoding,User-Agent \n Last-Modified: Sun, 19 Mar 2006 19:38:15 GMT \n Via: 1.1 webcache (NetCache NetApp/6.0.1P3) ";
            //Header = "GET /CNN/Programs/nancy.grace/ HTTP/1.0 \n Host:" +"www.techinnova.net \n "
            //    + "Connection: Keep-Alive \n" + live;
            //Headers = new WebHeaderCollection();

            //byte[] bytes = new byte[10];
            //while (socket.Receive(bytes, 0, 1, SocketFlags.None) > 0)
            //{
            //    Header += Encoding.ASCII.GetString(bytes, 0, 1);
            //    if (bytes[0] == '\n' && Header.EndsWith("\r\n\r\n"))
            //        break;
            //}
            //Header += live;
            Header = "";
            Headers = new WebHeaderCollection();

            byte[] bytes = new byte[10];
            while (socket.Receive(bytes, 0, 1, SocketFlags.None) > 0)
            {
                Header += Encoding.ASCII.GetString(bytes, 0, 1);
                if (bytes[0] == '\n' && Header.EndsWith("\r\n\r\n"))
                    break;
            }
            MatchCollection matches = new Regex("[^\r\n]+").Matches(Header.TrimEnd('\r', '\n'));
            for (int n = 1; n < matches.Count; n++)
            {
                string[] strItem = matches[n].Value.Split(new char[] { ':' }, 2);
                if (strItem.Length > 0)
                    Headers[strItem[0].Trim()] = strItem[1].Trim();
            }
            // check if the page should be transfered to another location
            if (matches.Count > 0 && (
                matches[0].Value.IndexOf(" 302 ") != -1 ||
                matches[0].Value.IndexOf(" 301 ") != -1))
                // check if the new location is sent in the "location" header
                if (Headers["Location"] != null)
                {
                    try { ResponseUri = new Uri(Headers["Location"]); }
                    catch { ResponseUri = new Uri(ResponseUri, Headers["Location"]); }
                }
            ContentType = Headers["Content-Type"];
            if (Headers["Content-Length"] != null)
                ContentLength = int.Parse(Headers["Content-Length"]);
            KeepAlive = (Headers["Connection"] != null && Headers["Connection"].ToLower() == "keep-alive") ||
                        (Headers["Proxy-Connection"] != null && Headers["Proxy-Connection"].ToLower() == "keep-alive");
        }
        public void Close()
        {
            socket.Close();
        }
        public Uri ResponseUri;
        public string ContentType;
        public int ContentLength;
        public WebHeaderCollection Headers;
        public string Header;
        public Socket socket;
        public bool KeepAlive;
    }


}
