// Copyright 2005 Google Inc.
// All Rights Reserved
//
// This file contains common Javascript routines used by blogsearch

function _el(i) {
  return document.getElementById(i);
}

function copyFormField(formdest, formsrc, field) {
  for (var i = 0; i < formsrc.elements.length; ++i) {
    if (formsrc.elements[i].name == field) {
      setFormField(formdest, field, formsrc.elements[field].value);
      return;
    }
  }
}

function formChildFocus(formsrc, field) {
  for (var i = 0; i < formsrc.elements.length; ++i) {
    if (formsrc.elements[i].name == field) {
      formsrc.elements[i].focus();
      return;
    }
  }
}

function getElementsByClass(tagType, classname) {
  var tmp = document.getElementsByTagName(tagType);
  var things = [];
  for (var i = 0; i < tmp.length; ++i) {
    if (tmp.item(i).className == classname){
      things[ things.length ] = tmp.item(i);
    }
  }
  return things;
}

function linktitle() {
  var linkz = document.getElementsByTagName('a');
  for (var i = 0; i < linkz.length; ++i) {
    if (linkz[i].title == "") {
      var hr = linkz[i].href;
      if (hr.length > 56) {
        hr = hr.slice(0,56) + "...";
      }
      linkz[i].title = hr;
    }
  }
}

function setFormField(form, field, value) {
  // lookup via form.elements[field] fails in IE
  for (var i = 0; i < form.elements.length; ++i) {
    if (form.elements[i].name == field) {
      form.elements[i].value = value;
      return;
    }
  }
  // Didn't find it - create it
  var f = document.createElement('input');
  f.type = 'hidden';
  f.name = field;
  f.value = value;
  form.appendChild(f);
}
